/* 
 * The Biomechanical ToolKit
 * Copyright (c) 2009-2013, Arnaud Barré
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *     * Redistributions of source code must retain the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer.
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials
 *       provided with the distribution.
 *     * Neither the name(s) of the copyright holders nor the names
 *       of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written
 *       permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
 
#include "btkIOSwig.h"

// ------------------------------------------------------------------------- //
//                             AcquisitionFileIO                             //
// ------------------------------------------------------------------------- //

// ------------------------------------------------------------------------- //
//                           AcquisitionFileReader                           //
// ------------------------------------------------------------------------- //
BTK_SWIG_DEFINE_DEFAULT_CTOR(AcquisitionFileReader);

// ------------------------------------------------------------------------- //
//                           AcquisitionFileWriter                           //
// ------------------------------------------------------------------------- //
BTK_SWIG_DEFINE_DEFAULT_CTOR(AcquisitionFileWriter);

// ------------------------------------------------------------------------- //
//                                  C3DFileIO                                //
// ------------------------------------------------------------------------- //
BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(C3DFileIO);

// ------------------------------------------------------------------------- //
//                                  ANBFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(ANBFileIO);

// ------------------------------------------------------------------------- //
//                                  ANCFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(ANCFileIO);

// ------------------------------------------------------------------------- //
//                                  ANGFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(ANGFileIO);

// ------------------------------------------------------------------------- //
//                             CALForcePlateFileIO                           //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(CALForcePlateFileIO);

// ------------------------------------------------------------------------- //
//                                  CLBFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(CLBFileIO);

// ------------------------------------------------------------------------- //
//                               DelsysEMGFileIO                             //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(DelsysEMGFileIO);

// ------------------------------------------------------------------------- //
//                                  EMFFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(EMFFileIO);

// ------------------------------------------------------------------------- //
//                                  EMxFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(EMxFileIO);

// ------------------------------------------------------------------------- //
//                                  GRxFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(GRxFileIO);

// ------------------------------------------------------------------------- //
//                                  MDFFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(MDFFileIO);

// ------------------------------------------------------------------------- //
//                                  MOMFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(MOMFileIO);

// ------------------------------------------------------------------------- //
//                                  PWRFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(PWRFileIO);

// ------------------------------------------------------------------------- //
//                                  RAxFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(RAxFileIO);

// ------------------------------------------------------------------------- //
//                                  RICFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(RICFileIO);

// ------------------------------------------------------------------------- //
//                                 TDFFileIO                                 //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(TDFFileIO);

// ------------------------------------------------------------------------- //
//                                  TRBFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(TRBFileIO);

// ------------------------------------------------------------------------- //
//                                  TRCFileIO                                //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(TRCFileIO);

// ------------------------------------------------------------------------- //
//                             XLSOrthoTrakFileIO                            //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(XLSOrthoTrakFileIO);

// ------------------------------------------------------------------------- //
//                                 XMOVEFileIO                               //
// ------------------------------------------------------------------------- //

BTK_SWIG_DEFINE_DEFAULT_IO_CTOR(XMOVEFileIO);
